library char_node;

class CharNode {
  int x, y;
  String char = "x";
  String color = "#8989B3";
  String backgroundColor = "#00FFFFFF";
  List<String> classes = new List<String>();
  Map<String, String> styles = new Map<String, String>();
  
  StringBuffer _sbClasses, _sbStyles;
  
  CharNode(this.x, this.y, this.char) { 
    classes.add("char_node");
    _sbClasses = new StringBuffer();
    _sbStyles = new StringBuffer();
    print(_sbClasses.toString());
  }
  
  String getChar() {
    if(classes.length > 1) {
      _sbClasses = new StringBuffer();
      _sbClasses.write('class="');
      for(int i = 0; i < classes.length; i++) {
        _sbClasses.write(' ${classes[i]}');
      }
      _sbClasses.write('"');
    }
    if(styles.length > 1) {
      _sbStyles = new StringBuffer();
      styles.forEach((k, v) {
        _sbStyles.write("$k: $v;");
      });
    }
    
    print(_sbStyles.toString());
    return '<span ${_sbClasses.toString()} style="color: $color; background-color: ${backgroundColor}; ${_sbStyles}">$char</span>';
  }
}